create database benefits with log;

create table employee
  (
	ssn     		integer		not null,
	pin		varchar(8,0),
       	name    		varchar(50,0),
	employer_id	integer,
	address 		varchar(50,0),
	city    		varchar(20,0),
	state   		varchar(5,0),
	zip     		varchar(10,0),
	hphone  		varchar(20,0),
	wphone		varchar(20,0),
	marital 		varchar(5,0),
	gender		varchar(5,0),	
	birthdate		varchar(10,0),
	occupation	varchar(30)
  );


create table employer
  (
	name            	varchar(50,0) not null,
	employer_id	varchar(20,0),
	control_no      	varchar(20,0),
        	suffix         	varchar(20,0),
        	account         	varchar(20,0),
	plan_no		varchar(20,0),
	claim_office_code 	varchar(20,0),
	customer_code	varchar(20,0),
	address         	varchar(50,0),
	city            	varchar(20,0),
	state           	varchar(5,0),
	zip             	varchar(10,0),
	phone           	varchar(20,0),
        	admin_name      	varchar(50,0),
        	admin_email     	varchar(50,0)
  );


create table dependent
  (
	employee_ssn   		integer 	not null,
	ssn    			integer		not null,
	name    		varchar(50,0),
        action			varchar(5,0),
	birthdate		varchar(10,0),
	relationship		varchar(5,0),
	PCP_name		varchar(50,0),
	PCP_no			varchar(15,0),
	prev_seen		varchar(5,0),
	obgyn_name		varchar(50,0),
	obgyn_no		varchar(15,0),
	obgyn_prev_seen		varchar(5,0),
        medicare        	varchar(5,0),
        medicare_no		varchar(15,0),
        medicaid_no		varchar(15,0),
        handicapped     	varchar(5,0),
        full_time_student	varchar(5,0),
        school 			varchar(50,0),
        grad_date 		varchar(10,0)
  );


create table primary_coverage
  (
	employee_ssn    	integer 		not null,
	plan_code	integer		not null,
	medicare_elig	varchar(5,0),
	medicare_no	varchar(15,0),
	medicaid_no	varchar(15,0)
  );


create table secondary_coverage
  (
	employee_ssn    integer 	not null,
	plan_name	varchar(50,0),
	effective_date	varchar(10,0),
	participant_name	varchar(50,0),
	policy_no	varchar(15,0),
	group_no	varchar(15,0)
  );


create table previous_coverage
  (
	employee_ssn     	integer 	not null,
	prev_cov_thisplan		varchar(5,0),
	names			varchar(50,0),
	effective_date1		varchar(10,0),
	employment_status		varchar(5,0),
	prev_cov_withco		varchar(5,0),
                prior_carrier		varchar(50,0),
	effective_date2		varchar(10,0)
	
  );


create table beneficiary
  (
	employee_ssn     	integer 	not null,	
	name1			varchar(50),
	relationship1		varchar(1),
        name2                   varchar(50),
        relationship2           varchar(1)

  );


create table benefit_plan
  (
	plan_id		integer	not null,
	plan_descp	varchar(50,0) not null, 
        plan_cost       varchar(50,0)
  );


create table dep_rel
  (
	rel_id		integer,
	rel_descp	varchar(10)
  );


create table transaction
  (
	ssn     		integer		not null,
       	trans_type    	varchar(5,0),
	trans_desc 	varchar(50,0),
     	other_desc	varchar(50,0),
	e_effective_date	varchar(10,0),
	e_qual_event	varchar(10,0),
        	c_effective_date	varchar(10,0),
	c_qual_event	varchar(10,0),
	done            	varchar(5,0),
      	date_done       	varchar(10,0)
  );

create table status
(             	
	employee_ssn	integer		not null,
        cs1		varchar(5,0),
        cs2		varchar(5,0),
        cs3		varchar(5,0),
        cs4		varchar(5,0),
        cs5		varchar(5,0),
        cs6		varchar(5,0),
	cs7		varchar(5,0)
);

create table hr_notes
(
       note_id  	integer		not null,
       note		varchar(50,0)
);

load from "employee.unl" insert into employee;
load from "employer.unl" insert into employer;
load from "benplan.unl" insert into benefit_plan;
load from "deprel.unl" insert into dep_rel;
load from "previous.unl" insert into previous_coverage;
load from "second.unl" insert into secondary_coverage;
load from "depend.unl" insert into dependent;
load from "trans.unl" insert into transaction;
load from "status.unl" insert into status;
load from "hrnotes.unl" insert into hr_notes;

grant resource to public;
