import java.awt.*;
import java.util.*;
import java.net.URL;
import java.io.InputStream;

public class TickerTape extends java.applet.Applet implements Runnable {

  String message;
  Font the_font;
  int messageWidth;
  int position;
  int update_seconds = 0;
  Date update_time = null;
  URL update = null;
  URL link = null;
  InputStream info;
  Thread ticker = null;
  boolean reload_ever = true;
  boolean reload = false;
  boolean suspend = false;
  int rest = 100;
  int rate = 5;

  public void init() {
    
    String tmpParam;
    tmpParam = getParameter("fsize");
    if (tmpParam != null) {
      int font_size = new Integer(tmpParam).intValue();
      the_font = new Font(getFont().getName(), getFont().getStyle(),font_size);
      setFont(the_font);
    }

    tmpParam = getParameter("bgcolor");
    if (tmpParam != null) {
      setBackground(new Color(Integer.valueOf(tmpParam, 16).intValue()));
    }

    tmpParam = getParameter("textcolor");
    if (tmpParam != null) {
      setForeground(new Color(Integer.valueOf(tmpParam, 16).intValue()));
    }

    tmpParam = getParameter("update");
    if (tmpParam != null) {
      update_seconds = new Integer(tmpParam).intValue();
      update_time = new Date();
      update_time.setTime(update_time.getTime() + (update_seconds * 1000));
    }

    message = getParameter("message");
    if (tmpParam == null) {
      reload_ever = false;
    } else {
      try {    
	update = new URL(getDocumentBase(), tmpParam); 
      } catch (java.net.MalformedURLException e) {reload_ever = false;}
      if ((getMessage() == false) && (message == null)) {
         message = "Stonebridge Technologies";
      }
    }

    messageWidth = getFontMetrics(getFont()).stringWidth(message); 
    tmpParam = getParameter("link");
    try {
      link = new URL (getDocumentBase(), tmpParam);
    } catch (java.net.MalformedURLException e) {link = null;}
    position = (rate < 0) ? -messageWidth : size().width;
  }

  boolean getMessage() {
    if (reload_ever == true) {
      try {
	info = update.openStream();
      } catch (java.io.IOException e) {
	return false;
      }
    
      StringBuffer makeMessage = new StringBuffer();
      char in;
      try {
	in = (char)info.read(); 
      } catch (java.io.IOException e) {
	return false;
      }
      while (in != '\n') {
	makeMessage.append(in);
	try {
	  in = (char)info.read(); 
	} catch (java.io.IOException e) {
	  return false;
	}
      }

      try {
	info.close();
      } catch (java.io.IOException e) {
	reload_ever = false;
      }
      message = makeMessage.toString();
    }
    return true;
  }


  public void start() {
    if (ticker == null) {
      ticker = new Thread(this);
      ticker.start();
    }
  }

  public void stop() {
    ticker = null;
  }

  public void run() {
    while (ticker != null) {
      repaint();
      if (((rate < 0) && (position > size().width)) ||
	  (position < -messageWidth)) {
        position = (rate < 0) ? -messageWidth : size().width;
	if ((update_time != null) && (new Date()).after(update_time)) {
	  reload = true;
	}
	
	if (reload == true) {
	  getMessage();
	  messageWidth = getFontMetrics(getFont()).stringWidth(message); 
	  reload = false;
	  if (update_time != null) {
	    update_time = new Date();
	    update_time.setTime(update_time.getTime() +(update_seconds * 1000));
	  }
	}
      }
      try {
	Thread.sleep(rest);
      }
      catch (InterruptedException e) {ticker = null;}
      position -= rate;
    }
  }

  public boolean keyUp(java.awt.Event evt, int key) {
    update_status();
    return true;
  }

  public boolean mouseUp(java.awt.Event evt, int x, int y) {
    if (link == null) {
      reload = true;
    } else {
      getAppletContext().showDocument(link);
    }
    return true;
  }

  public void update_status() {
    if (link != null) 
      	showStatus(link.toExternalForm());
  }

  public boolean mouseEnter(java.awt.Event evt, int x, int y) {
    update_status();
    return true;
  }

  public boolean mouseExit(java.awt.Event evt, int x, int y) {
    if (link != null) {
      showStatus("");
    }
    return true;
  }
                            
  public void paint(Graphics g) {
    g.drawString(message, position, getFont().getSize());
  }

}
